## rhash 1.4.5

=== Makefile ===

include config.mak

HEADERS = calc_sums.h hash_print.h common_func.h hash_update.h file.h file_mask.h file_set.h find_file.h hash_check.h output.h parse_cmdline.h rhash_main.h win_utils.h platform.h version.h
SOURCES = calc_sums.c hash_print.c common_func.c hash_update.c file.c file_mask.c file_set.c find_file.c hash_check.c output.c parse_cmdline.c rhash_main.c win_utils.c
OBJECTS = $(SOURCES:.c=.o)
WIN_DIST_FILES = dist/MD5.bat dist/magnet.bat dist/rhashrc.sample
OTHER_FILES = configure Makefile ChangeLog INSTALL.md COPYING README.md \
  build/vc-2010/rhash.vcxproj dist/rhash.spec.in dist/rhash.1.in dist/rhash.1.win.sed \
  docs/CONTRIBUTING.md docs/LIBRHASH.md librhash/Doxyfile po/rhash.pot \
  tests/test_rhash.sh tests/test1K.data
LIBRHASH_FILES  = librhash/algorithms.c librhash/algorithms.h \
  librhash/byte_order.c librhash/byte_order.h librhash/plug_openssl.c librhash/plug_openssl.h \
  librhash/rhash.c librhash/rhash.h librhash/rhash_torrent.c librhash/rhash_torrent.h \
  librhash/aich.c librhash/aich.h librhash/blake2b.c librhash/blake2b.h \
  librhash/blake2s.c librhash/blake2s.h librhash/crc32.c librhash/crc32.h \
  librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
  librhash/gost12.c librhash/gost12.h librhash/gost94.c librhash/gost94.h \
  librhash/has160.c librhash/has160.h librhash/hex.c librhash/hex.h librhash/md4.c \
  librhash/md4.h librhash/md5.c librhash/md5.h librhash/ripemd-160.c librhash/ripemd-160.h \
  librhash/sha1.c librhash/sha1.h librhash/sha3.c librhash/sha3.h \
  librhash/sha256.c librhash/sha256.h librhash/sha512.c librhash/sha512.h \
  librhash/snefru.c librhash/snefru.h librhash/tiger.c librhash/tiger.h librhash/tiger_sbox.c \
  librhash/torrent.h librhash/torrent.c librhash/tth.c librhash/tth.h \
  librhash/whirlpool.c librhash/whirlpool.h librhash/whirlpool_sbox.c \
  librhash/test_lib.c librhash/test_lib.h librhash/test_utils.c librhash/test_utils.h \
  librhash/ustd.h librhash/util.c librhash/util.h librhash/Makefile
I18N_FILES  = po/ca.po po/de.po po/en_AU.po po/es.po po/fr.po po/gl.po po/it.po po/pt_BR.po po/ro.po po/ru.po po/uk.po
ALL_FILES   = $(SOURCES) $(HEADERS) $(LIBRHASH_FILES) $(OTHER_FILES) $(WIN_DIST_FILES) $(I18N_FILES)
SPECFILE    = dist/rhash.spec
LIBRHASH_PC = dist/librhash.pc
RPMTOP      = rpms
RPMDIRS     = SOURCES SPECS BUILD SRPMS RPMS
RHASH_NAME      = rhash
RHASH_BINARY    = rhash$(EXEC_EXT)
INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644

all: $(BUILD_TARGETS)
build: $(RHASH_BINARY)
lib-shared: $(LIBRHASH_SHARED)
lib-static: $(LIBRHASH_STATIC)
install: build-install-binary install-data install-symlinks $(EXTRA_INSTALL)
install-data: install-man install-conf
uninstall: uninstall-binary uninstall-data uninstall-symlinks uninstall-lib uninstall-gmo uninstall-pkg-config

config.mak:
	echo "Run the ./configure script first" && false

# creating archives
WIN_SUFFIX     = win32
PACKAGE_NAME   = $(RHASH_NAME)-$(VERSION)
ARCHIVE_TARGZ  = $(PACKAGE_NAME)-src.tar.gz
ARCHIVE_TARGZ_CORE     = $(RHASH_NAME)-core-$(VERSION)-src.tar.gz
ARCHIVE_TARGZ_BINDINGS = $(RHASH_NAME)-bindings-$(VERSION)-src.tar.gz
ARCHIVE_TARGZ_DEB      = $(RHASH_NAME)_$(VERSION).orig.tar.gz
ARCHIVE_XZ     = $(PACKAGE_NAME)-src.tar.xz
ARCHIVE_ZIP    = $(PACKAGE_NAME)-$(WIN_SUFFIX).zip
WIN_ZIP_DIR    = RHash-$(VERSION)-$(WIN_SUFFIX)
dist: tgz
win-dist: zip
zip: $(ARCHIVE_ZIP)
dgz: check $(ARCHIVE_TARGZ_DEB)

build-install-binary: $(BUILD_TARGETS)
	+$(MAKE) install-binary

mkdir-bin:
	$(INSTALL) -d $(BINDIR)

# install binary without (re-)compilation
install-binary: mkdir-bin
	$(INSTALL_PROGRAM) $(RHASH_BINARY) $(BINDIR)/$(RHASH_BINARY)

install-man:
	$(INSTALL) -d $(MANDIR)/man1
	$(INSTALL_DATA) dist/rhash.1 $(MANDIR)/man1/rhash.1

install-conf:
	$(INSTALL) -d $(SYSCONFDIR)
	tr -d \\r < dist/rhashrc.sample > rc.tmp && $(INSTALL_DATA) rc.tmp $(SYSCONFDIR)/rhashrc
	rm -f rc.tmp

# dependencies should be properly set, otherwise 'make -j<n>' can fail
install-symlinks: mkdir-bin install-man install-binary
	cd $(BINDIR) && for f in $(SYMLINKS); do $(LN_S) $(RHASH_BINARY) $$f$(EXEC_EXT); done
	cd $(MANDIR)/man1 && for f in $(SYMLINKS); do $(LN_S) rhash.1 $$f.1; done

install-pkg-config:
	$(INSTALL) -d $(PKGCONFIGDIR)
	$(INSTALL_DATA) $(LIBRHASH_PC) $(PKGCONFIGDIR)/

uninstall-binary:
	rm -f $(BINDIR)/$(RHASH_BINARY)

uninstall-data:
	rm -f $(MANDIR)/man1/rhash.1

uninstall-symlinks:
	for f in $(SYMLINKS); do rm -f $(BINDIR)/$$f$(EXEC_EXT) $(MANDIR)/man1/$$f.1; done

uninstall-pkg-config:
	rm -f $(PKGCONFIGDIR)/librhash.pc

uninstall-lib:
	+cd librhash && $(MAKE) uninstall-lib

install-lib-static: $(LIBRHASH_STATIC) install-lib-headers
	+cd librhash && $(MAKE) install-lib-static

install-lib-shared: $(LIBRHASH_SHARED)
	+cd librhash && $(MAKE) install-lib-shared

install-lib-headers:
	+cd librhash && $(MAKE) install-lib-headers

install-lib-so-link:
	+cd librhash && $(MAKE) install-so-link

$(LIBRHASH_SHARED): $(LIBRHASH_FILES)
	+cd librhash && $(MAKE) lib-shared

$(LIBRHASH_STATIC): $(LIBRHASH_FILES)
	+cd librhash && $(MAKE) lib-static

test-lib: test-lib-$(LIBRHASH_TYPE)

test-lib-static: $(LIBRHASH_STATIC)
	+cd librhash && $(MAKE) test-static

test-lib-shared: $(LIBRHASH_SHARED)
	+cd librhash && $(MAKE) test-shared

test-libs: $(LIBRHASH_STATIC) $(LIBRHASH_SHARED)
	+cd librhash && $(MAKE) test-static test-shared

test-full: $(RHASH_BINARY)
	/bin/sh tests/test_rhash.sh $(TEST_OPTIONS) --full ./$(RHASH_BINARY)

test: $(RHASH_BINARY)
	/bin/sh tests/test_rhash.sh $(TEST_OPTIONS) ./$(RHASH_BINARY)

print-info: lib-$(LIBRHASH_TYPE)
	+cd librhash && $(MAKE) print-info

# check that source tree is consistent
check:
	grep -q '\* === Version $(VERSION) ===' ChangeLog
	grep -q '^#define VERSION "$(VERSION)"' version.h
	test ! -f bindings/version.properties || grep -q '^version=$(VERSION)$$' bindings/version.properties

$(RHASH_BINARY): $(OBJECTS) $(LIBRHASH_PATH)
	$(CC) $(OBJECTS) $(LIBRHASH_PATH) $(LDFLAGS) -o $@

# NOTE: dependences were generated by 'gcc -Ilibrhash -MM *.c'
# we are using plain old makefile style to support BSD make
calc_sums.o: calc_sums.c calc_sums.h common_func.h file.h hash_check.h \
 file_set.h hash_print.h output.h parse_cmdline.h rhash_main.h \
 win_utils.h librhash/rhash.h librhash/rhash_torrent.h
	$(CC) -c $(CFLAGS) $< -o $@

common_func.o: common_func.c common_func.h output.h parse_cmdline.h \
 version.h win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

file.o: file.c file.h common_func.h parse_cmdline.h platform.h \
 win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

file_mask.o: file_mask.c file_mask.h common_func.h file.h
	$(CC) -c $(CFLAGS) $< -o $@

file_set.o: file_set.c file_set.h common_func.h hash_print.h output.h \
 parse_cmdline.h rhash_main.h file.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

find_file.o: find_file.c find_file.h common_func.h file.h output.h \
 parse_cmdline.h platform.h win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

hash_check.o: hash_check.c hash_check.h file.h file_set.h calc_sums.h \
 common_func.h hash_print.h output.h parse_cmdline.h rhash_main.h \
 librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

hash_print.o: hash_print.c hash_print.h calc_sums.h common_func.h file.h \
 hash_check.h file_set.h output.h parse_cmdline.h rhash_main.h \
 win_utils.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

hash_update.o: hash_update.c hash_update.h calc_sums.h common_func.h \
 file.h hash_check.h file_set.h file_mask.h hash_print.h output.h \
 parse_cmdline.h rhash_main.h win_utils.h
	$(CC) -c $(CFLAGS) $< -o $@

output.o: output.c output.h calc_sums.h common_func.h file.h hash_check.h \
 file_set.h parse_cmdline.h platform.h rhash_main.h win_utils.h \
 librhash/rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

parse_cmdline.o: parse_cmdline.c parse_cmdline.h calc_sums.h \
 common_func.h file.h hash_check.h file_set.h file_mask.h find_file.h \
 hash_print.h output.h rhash_main.h win_utils.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $(CONFCFLAGS) $< -o $@

rhash_main.o: rhash_main.c rhash_main.h file.h calc_sums.h common_func.h \
 hash_check.h file_set.h file_mask.h find_file.h hash_print.h \
 hash_update.h output.h parse_cmdline.h win_utils.h librhash/rhash.h
	$(CC) -c $(CFLAGS) $(LOCALECFLAGS) $< -o $@

win_utils.o: win_utils.c win_utils.h common_func.h file.h parse_cmdline.h
	$(CC) -c $(CFLAGS) $< -o $@

dist/rhash.1.win.html: dist/rhash.1 dist/rhash.1.win.sed
	sed -f dist/rhash.1.win.sed dist/rhash.1 | rman -fHTML -roff | \
	sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > dist/rhash.1.win.html
#	verify the result
	grep -q "utf8" dist/rhash.1.win.html
	grep -q "APPDATA" dist/rhash.1.win.html

dist/rhash.1.html: dist/rhash.1
	-rman --version 2>/dev/null && (rman -fHTML -roff dist/rhash.1 | sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > $@)

dist/rhash.1.txt: dist/rhash.1
	-groff --version 2>/dev/null && (groff -t -e -mandoc -Tascii dist/rhash.1 | sed -e 's/.\[[0-9]*m//g' > $@)

permissions:
	find . build dist docs librhash po tests -maxdepth 1 -type f -exec chmod -x '{}' \;
	chmod +x configure tests/test_rhash.sh

copy-dist: $(ALL_FILES) permissions
	rm -rf $(PACKAGE_NAME)
	mkdir $(PACKAGE_NAME)
	cp -rl --parents $(ALL_FILES) $(PACKAGE_NAME)/

tgz-core: check
	+$(MAKE) copy-dist PACKAGE_NAME=$(PACKAGE_NAME)-core
	tar czf $(ARCHIVE_TARGZ_CORE) --owner=root --group=root $(PACKAGE_NAME)-core/
	rm -rf $(PACKAGE_NAME)-core

tgz-bindings:
	+cd bindings && $(MAKE) gzip ARCHIVE_GZIP=../$(ARCHIVE_TARGZ_BINDINGS)

tgz: check clean-bindings
	+$(MAKE) copy-dist
	+cd bindings && $(MAKE) copy-dist COPYDIR=../$(PACKAGE_NAME)/bindings
	tar czf $(ARCHIVE_TARGZ) --owner=root:0 --group=root:0 $(PACKAGE_NAME)/
	rm -rf $(PACKAGE_NAME)

xz: check clean-bindings
	+$(MAKE) copy-dist
	+cd bindings && $(MAKE) copy-dist COPYDIR=../$(PACKAGE_NAME)/bindings
	tar cJf $(ARCHIVE_XZ) --owner=root:0 --group=root:0 $(PACKAGE_NAME)/
	rm -rf $(PACKAGE_NAME)

win-dir: $(WIN_DIST_FILES) dist/rhash.1.win.html
	test -s dist/rhash.1.win.html && test -x $(RHASH_BINARY)
	-rm -rf $(WIN_ZIP_DIR)
	mkdir $(WIN_ZIP_DIR)
	cp $(RHASH_BINARY) ChangeLog $(WIN_DIST_FILES) $(WIN_ZIP_DIR)/
	cp dist/rhash.1.win.html $(WIN_ZIP_DIR)/rhash-doc.html

$(ARCHIVE_ZIP): $(WIN_DIST_FILES) dist/rhash.1.win.html
	+$(MAKE) win-dir
	zip -9r $(ARCHIVE_ZIP) $(WIN_ZIP_DIR)
	rm -rf $(WIN_ZIP_DIR)

$(ARCHIVE_TARGZ_DEB) : $(ALL_FILES)
	+$(MAKE) tgz
	mv -f $(ARCHIVE_TARGZ) $(ARCHIVE_TARGZ_DEB)

# rpm packaging
$(SPECFILE): $(SPECFILE).in config.mak
	sed -e 's/@VERSION@/$(VERSION)/' $(SPECFILE).in > $(SPECFILE)

rpm: tgz
	-for i in $(RPMDIRS); do mkdir -p $(RPMTOP)/$$i; done
	cp -f $(ARCHIVE_TARGZ) $(RPMTOP)/SOURCES
	rpmbuild -ba --clean --define "_topdir `pwd`/$(RPMTOP)" $(SPECFILE)
	mv -f `find $(RPMTOP) -name "*rhash*-$(VERSION)*.rpm"` .
	rm -rf $(RPMTOP)

clean-bindings:
	+cd bindings && $(MAKE) clean

clean-local:
	rm -f *.o $(RHASH_BINARY)
	rm -f po/*.gmo po/*.po~ po/compile-gmo.tag

distclean: clean-local
	rm -f config.log config.mak dist/rhash.1 $(SPECFILE) $(LIBRHASH_PC)
	+cd librhash && $(MAKE) distclean

clean: clean-local
	+cd librhash && $(MAKE) clean

update-po:
	xgettext *.c -k_ -cTRANSLATORS -o po/rhash.pot \
		--msgid-bugs-address='Aleksey <rhash.admin@gmail.com>' --package-name='RHash'
	for f in $(I18N_FILES); do \
		msgmerge -U $$f po/rhash.pot; \
	done

po/compile-gmo.tag: $(I18N_FILES)
	for f in $(I18N_FILES); do \
		g=`basename $$f .po`; \
		msgfmt -o po/$$g.gmo $$f; \
	done
	touch $@

compile-gmo: po/compile-gmo.tag

install-gmo: compile-gmo
	for f in $(I18N_FILES); do \
		l=`basename $$f .po`; \
		$(INSTALL) -d $(LOCALEDIR)/$$l/LC_MESSAGES; \
		$(INSTALL_DATA) po/$$l.gmo $(LOCALEDIR)/$$l/LC_MESSAGES/rhash.mo; \
	done

uninstall-gmo:
	for f in $(I18N_FILES); do \
		rm -f $(LOCALEDIR)/`basename $$f .po`/LC_MESSAGES/rhash.mo; \
	done

.PHONY: all build lib-shared lib-static clean clean-bindings distclean clean-local \
	test test-shared test-static test-full test-lib test-libs test-lib-shared test-lib-static \

=== librhash/Makefile ===
# Makefile for LibRHash

include config.mak

HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_torrent.h aich.h blake2b.h blake2s.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost12.h gost94.h has160.h snefru.h tiger.h tth.h torrent.h ustd.h util.h whirlpool.h
SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_torrent.c aich.c blake2b.c blake2s.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost12.c gost94.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c util.c whirlpool.c whirlpool_sbox.c
OBJECTS = $(SOURCES:.c=.o)
LIB_HEADERS = rhash.h rhash_torrent.h
TEST_STATIC = test_static$(EXEC_EXT)
TEST_SHARED = test_shared$(EXEC_EXT)
INSTALL_DATA = $(INSTALL) -m 644
INSTALL_SHARED = $(INSTALL) -m $(SHARED_LIB_MODE)

all: $(BUILD_TARGETS)
lib-static: $(LIBRHASH_STATIC)
lib-shared: $(LIBRHASH_SHARED)
libs-all: lib-static lib-shared
uninstall-lib: uninstall-lib-shared uninstall-lib-static uninstall-so-link

config.mak:
	echo "Run the ./configure script first" && false

install-lib-static: $(LIBRHASH_STATIC)
	$(INSTALL) -d $(LIBDIR)
	$(INSTALL_DATA) $(LIBRHASH_STATIC) $(LIBDIR)/

install-lib-shared: $(LIBRHASH_SHARED) $(EXTRA_INSTALL_LIBSHARED)
	$(INSTALL) -d $(SO_DIR)
	$(INSTALL_SHARED) $(LIBRHASH_SHARED) $(SO_DIR)/
	test "x$(LIBRHASH_SO_MAJ)" = "x$(LIBRHASH_SHARED)" || ( \
	  rm -f $(LIBDIR)/$(LIBRHASH_SO_MAJ) && \
	  ln -s $(LIBRHASH_SHARED) $(LIBDIR)/$(LIBRHASH_SO_MAJ) )

install-implib:
	$(INSTALL) -d $(LIBDIR)
	$(INSTALL_DATA) $(LIBRHASH_IMPLIB) $(LIBDIR)/

install-so-link:
	$(INSTALL) -d $(LIBDIR)
	rm -f $(LIBDIR)/$(LIBRHASH_SOLINK)
	ln -s $(LIBRHASH_SO_MAJ) $(LIBDIR)/$(LIBRHASH_SOLINK)

uninstall-lib-static: uninstall-lib-headers
	rm -f $(LIBDIR)/$(LIBRHASH_STATIC)

uninstall-lib-shared: $(EXTRA_UNINSTALL_LIBSHARED)
	rm -f $(SO_DIR)/$(LIBRHASH_SHARED) $(SO_DIR)/$(LIBRHASH_SO_MAJ)

uninstall-implib:
	rm -f $(LIBDIR)/$(LIBRHASH_IMPLIB)

uninstall-so-link:
	rm -f $(LIBDIR)/$(LIBRHASH_SOLINK)

install-lib-headers:
	$(INSTALL) -d $(INCDIR)
	$(INSTALL_DATA) $(LIB_HEADERS) $(INCDIR)/

uninstall-lib-headers:
	for f in $(LIB_HEADERS); do rm -f "$(INCDIR)/$$f"; done

# not using GNU make extensions for compatibility with Unix/*BSD make
#%.o: %.c
#	$(CC) -c $(CFLAGS) $< -o $@

# NOTE: dependences were generated by 'gcc -MM -DUSE_OPENSSL *.c'
# we are using plain old makefile style to support BSD make
aich.o: aich.c aich.h algorithms.h rhash.h byte_order.h ustd.h sha1.h \
 util.h
	$(CC) -c $(CFLAGS) $< -o $@

algorithms.o: algorithms.c algorithms.h rhash.h byte_order.h ustd.h \
 aich.h sha1.h blake2b.h blake2s.h crc32.h ed2k.h md4.h edonr.h gost12.h \
 gost94.h has160.h md5.h ripemd-160.h snefru.h sha256.h sha512.h sha3.h \
 tiger.h torrent.h tth.h whirlpool.h
	$(CC) -c $(CFLAGS) $< -o $@

blake2b.o: blake2b.c blake2b.h ustd.h byte_order.h
	$(CC) -c $(CFLAGS) $< -o $@

blake2s.o: blake2s.c blake2s.h ustd.h byte_order.h
	$(CC) -c $(CFLAGS) $< -o $@

byte_order.o: byte_order.c byte_order.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

crc32.o: crc32.c byte_order.h ustd.h crc32.h
	$(CC) -c $(CFLAGS) $< -o $@

ed2k.o: ed2k.c ed2k.h md4.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

edonr.o: edonr.c byte_order.h ustd.h edonr.h
	$(CC) -c $(CFLAGS) $< -o $@

gost12.o: gost12.c gost12.h ustd.h byte_order.h
	$(CC) -c $(CFLAGS) $< -o $@

gost94.o: gost94.c gost94.h ustd.h byte_order.h
	$(CC) -c $(CFLAGS) $< -o $@

has160.o: has160.c byte_order.h ustd.h has160.h
	$(CC) -c $(CFLAGS) $< -o $@

hex.o: hex.c hex.h ustd.h util.h
	$(CC) -c $(CFLAGS) $< -o $@

md4.o: md4.c byte_order.h ustd.h md4.h
	$(CC) -c $(CFLAGS) $< -o $@

md5.o: md5.c byte_order.h ustd.h md5.h
	$(CC) -c $(CFLAGS) $< -o $@

plug_openssl.o: plug_openssl.c
	$(CC) -c $(CFLAGS) $< -o $@

rhash.o: rhash.c rhash.h algorithms.h byte_order.h ustd.h hex.h \
 plug_openssl.h torrent.h sha1.h util.h
	$(CC) -c $(CFLAGS) $(VERSION_CFLAGS) $< -o $@

rhash_torrent.o: rhash_torrent.c rhash_torrent.h algorithms.h rhash.h \
 byte_order.h ustd.h torrent.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

ripemd-160.o: ripemd-160.c byte_order.h ustd.h ripemd-160.h
	$(CC) -c $(CFLAGS) $< -o $@

sha1.o: sha1.c byte_order.h ustd.h sha1.h
	$(CC) -c $(CFLAGS) $< -o $@

sha256.o: sha256.c byte_order.h ustd.h sha256.h
	$(CC) -c $(CFLAGS) $< -o $@

sha3.o: sha3.c byte_order.h ustd.h sha3.h
	$(CC) -c $(CFLAGS) $< -o $@

sha512.o: sha512.c byte_order.h ustd.h sha512.h
	$(CC) -c $(CFLAGS) $< -o $@

snefru.o: snefru.c byte_order.h ustd.h snefru.h
	$(CC) -c $(CFLAGS) $< -o $@

test_lib.o: test_lib.c byte_order.h ustd.h rhash_torrent.h test_utils.h \
 rhash.h test_lib.h util.h
	$(CC) -c $(CFLAGS) $< -o $@

test_utils.o: test_utils.c test_utils.h byte_order.h ustd.h rhash.h
	$(CC) -c $(CFLAGS) $< -o $@

tiger.o: tiger.c byte_order.h ustd.h tiger.h
	$(CC) -c $(CFLAGS) $< -o $@

tiger_sbox.o: tiger_sbox.c byte_order.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

torrent.o: torrent.c torrent.h algorithms.h rhash.h byte_order.h ustd.h \
 sha1.h hex.h util.h
	$(CC) -c $(CFLAGS) $< -o $@

tth.o: tth.c tth.h ustd.h tiger.h byte_order.h
	$(CC) -c $(CFLAGS) $< -o $@

util.o: util.c util.h
	$(CC) -c $(CFLAGS) $< -o $@

whirlpool.o: whirlpool.c byte_order.h ustd.h whirlpool.h
	$(CC) -c $(CFLAGS) $< -o $@

whirlpool_sbox.o: whirlpool_sbox.c byte_order.h ustd.h
	$(CC) -c $(CFLAGS) $< -o $@

# build shared library
$(EXPORTS_FILE): $(LIB_HEADERS)
	sed -ne '1s/.*/{ global:/p; s/^RHASH_API.* \(rhash_[a-z0-9_]*\)(.*/  \1;/p; $$s/.*/local: *; };/p' \
	  $(LIB_HEADERS) | grep -v "$(EXPORTS_SKIP)" > $@

$(LIBRHASH_SOLINK):
	test "x$(LIBRHASH_SO_MAJ)" = "x$(LIBRHASH_SHARED)" || ( \
	  rm -f $(LIBRHASH_SO_MAJ) && \
	  ln -s $(LIBRHASH_SHARED) $(LIBRHASH_SO_MAJ) )
	rm -f $(LIBRHASH_SOLINK)
	ln -s $(LIBRHASH_SO_MAJ) $(LIBRHASH_SOLINK)

$(LIBRHASH_SHARED): $(SOURCES) $(EXPORTS_TARGET) $(SOLINK_TARGET)
	$(CC) $(SHARED_CFLAGS) $(VERSION_CFLAGS) $(SOURCES) $(SHARED_LDFLAGS) -o $@

# build static library
$(LIBRHASH_STATIC): $(OBJECTS)
	rm -f $@
	$(AR) -cqs $@ $(OBJECTS)

# test targets
$(TEST_SHARED): $(LIBRHASH_SHARED) test_lib.o test_utils.o
	$(CC) $(CFLAGS) test_lib.o test_utils.o $(LIBRHASH_SHARED) $(LDFLAGS) -o $@

$(TEST_STATIC): $(LIBRHASH_STATIC) test_lib.o test_utils.o
	$(CC) $(CFLAGS) test_lib.o test_utils.o $(LIBRHASH_STATIC) $(BIN_STATIC_LDFLAGS) -o $@

test: $(TEST_TARGETS)
test-static: $(TEST_STATIC)
	./$(TEST_STATIC)
test-shared: $(TEST_SHARED)
	LD_LIBRARY_PATH=.:$(LD_LIBRARY_PATH) DYLD_LIBRARY_PATH=.:$(DYLD_LIBRARY_PATH) ./$(TEST_SHARED)

print-info: print-info-$(BUILD_TYPE)
print-info-static: $(TEST_STATIC)
	./$(TEST_STATIC) --info
print-info-shared: $(TEST_SHARED)
	LD_LIBRARY_PATH=.:$(LD_LIBRARY_PATH) DYLD_LIBRARY_PATH=.:$(DYLD_LIBRARY_PATH) ./$(TEST_SHARED) --info

distclean: clean
	rm -f config.mak

clean:
	rm -f *.o $(LIBRHASH_STATIC) $(LIBRHASH_SHARED) $(TEST_STATIC) $(TEST_SHARED) $(RM_FILES)

.PHONY: all clean distclean install-lib-headers install-lib-shared install-lib-static \
	install-so-link libs-all lib-shared lib-static test test-shared test-static \
	print-info print-info-static print-info-shared uninstall-lib-headers \
	uninstall-lib uninstall-lib-shared uninstall-lib-static uninstall-so-link \
	install-implib uninstall-implib

=== bindings/java/native/Makefile ===
#!/usr/bin/make -f

# This file is a part of Java Bindings for Librhash
#
# Copyright (c) 2011, Sergey Basalaev <sbasalaev@gmail.com>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE  INCLUDING ALL IMPLIED WARRANTIES OF  MERCHANTABILITY
# AND FITNESS.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT,  OR CONSEQUENTIAL DAMAGES  OR ANY DAMAGES WHATSOEVER RESULTING FROM
# LOSS OF USE,  DATA OR PROFITS,  WHETHER IN AN ACTION OF CONTRACT,  NEGLIGENCE
# OR OTHER TORTIOUS ACTION,  ARISING OUT OF  OR IN CONNECTION  WITH THE USE  OR
# PERFORMANCE OF THIS SOFTWARE.

CC ?= gcc
JAVAC ?= javac
CFLAGS ?= -g -O2
LDFLAGS ?=
LIBRHASH_INC ?=
LIBRHASH_LD  ?=
ALLLDFLAGS = $(LDFLAGS) -lrhash $(LIBRHASH_LD)
ALLCFLAGS = $(CFLAGS) $(LIBRHASH_INC) -fPIC

#Platform dependent
JAVAC_PATH = $(shell readlink -f $(shell command -v $(JAVAC)))
JDK_HOME ?=$(realpath $(dir $(JAVAC_PATH))/..)
JNI_CFLAGS1 = $(shell test -d "$(JDK_HOME)/include" && echo -I$(JDK_HOME)/include)
JNI_CFLAGS2 = $(shell test -d "$(JDK_HOME)/include/linux" && echo -I$(JDK_HOME)/include/linux)
JNI_CFLAGS ?= $(JNI_CFLAGS1) $(JNI_CFLAGS2)
LIB_PREFIX ?= lib
LIB_SUFFIX ?= .so

OBJECTS = bindings.o digest.o
LIBRARY = $(LIB_PREFIX)rhash-jni$(LIB_SUFFIX)

all: $(LIBRARY)

bindings.o: bindings.c bindings.h
	$(CC) $(ALLCFLAGS) $(JNI_CFLAGS) -c $< -o $@

digest.o: digest.c digest.h
	$(CC) $(ALLCFLAGS) -c $< -o $@

$(LIBRARY): $(OBJECTS)
	$(CC) -shared -o $@ $(OBJECTS) $(ALLLDFLAGS)

clean:
	rm -f *.o $(LIBRARY)

=== debian/changelog ===
rhash (1.4.5-1) unstable; urgency=medium

  * New upstream version 1.4.5
  * d/patches: Drop obsolete patches
  * librhash1.symbols: Add rhash_ctrl function

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Mon, 14 Oct 2024 23:33:02 +0300

=== debian/control ===
Source: rhash
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
Build-Depends: debhelper-compat (= 13), libssl-dev (>= 3.0.0)
Standards-Version: 4.7.0
Homepage: http://rhash.sourceforge.net
Vcs-Git: https://salsa.debian.org/pkg-security-team/rhash.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/rhash
Rules-Requires-Root: no

Package: rhash
Architecture: any
Depends: librhash1 (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl3
Description: utility for computing hash sums and magnet links
 RHash is a console utility for calculation and verification of magnet links
 and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Output in a predefined (SFV, BSD-like) or a user-defined format.
  * Can calculate Magnet links.
  * Ability to process directories recursively.
  * Updating hash files (adding hash sums of files missing in the hash file).
  * Portability: the program works the same on Linux, *BSD or Windows.

Package: librhash1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl3
Multi-Arch: same
Description: shared library for hash functions computing
 LibRHash is a professional, portable, thread-safe C library for computing
 magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
 SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
 GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaneously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash-dev
Architecture: any
Section: libdevel
Depends: librhash1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: header files and a static library for librhash
 LibRHash is a professional, portable, thread-safe C library for computing
 magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
 SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
 GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains LibRHash static library and header files.

## rhash 1.4.6

=== librhash/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 include config.mak
 
-HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_torrent.h aich.h blake2b.h blake2s.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost12.h gost94.h has160.h snefru.h tiger.h tth.h torrent.h ustd.h util.h whirlpool.h
-SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_torrent.c aich.c blake2b.c blake2s.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost12.c gost94.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c util.c whirlpool.c whirlpool_sbox.c
+HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_torrent.h aich.h blake2b.h blake2s.h blake3.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha_ni.h sha256.h sha512.h sha3.h ripemd-160.h gost12.h gost94.h has160.h snefru.h tiger.h tth.h torrent.h ustd.h util.h whirlpool.h
+SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_torrent.c aich.c blake2b.c blake2s.c blake3.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha_ni.c sha256.c sha512.c sha3.c ripemd-160.c gost12.c gost94.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c util.c whirlpool.c whirlpool_sbox.c
 OBJECTS = $(SOURCES:.c=.o)
 LIB_HEADERS = rhash.h rhash_torrent.h
 TEST_STATIC = test_static$(EXEC_EXT)
@@ -70,9 +70,10 @@
 	$(CC) -c $(CFLAGS) $< -o $@
 
 algorithms.o: algorithms.c algorithms.h rhash.h byte_order.h ustd.h \
- aich.h sha1.h blake2b.h blake2s.h crc32.h ed2k.h md4.h edonr.h gost12.h \
- gost94.h has160.h md5.h ripemd-160.h snefru.h sha256.h sha512.h sha3.h \
- tiger.h torrent.h tth.h whirlpool.h
+ util.h aich.h sha1.h blake2b.h blake2s.h blake3.h crc32.h ed2k.h md4.h \
+ edonr.h gost12.h gost94.h has160.h md5.h ripemd-160.h snefru.h sha_ni.h \
+ sha256.h sha512.h sha3.h tiger.h torrent.h tth.h whirlpool.h \
+ plug_openssl.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
 blake2b.o: blake2b.c blake2b.h ustd.h byte_order.h
@@ -81,6 +82,9 @@
 blake2s.o: blake2s.c blake2s.h ustd.h byte_order.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
+blake3.o: blake3.c blake3.h ustd.h byte_order.h
+	$(CC) -c $(CFLAGS) $< -o $@
+
 byte_order.o: byte_order.c byte_order.h ustd.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
@@ -111,7 +115,8 @@
 md5.o: md5.c byte_order.h ustd.h md5.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
-plug_openssl.o: plug_openssl.c
+plug_openssl.o: plug_openssl.c util.h plug_openssl.h algorithms.h rhash.h \
+ byte_order.h ustd.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
 rhash.o: rhash.c rhash.h algorithms.h byte_order.h ustd.h hex.h \
@@ -126,6 +131,9 @@
 	$(CC) -c $(CFLAGS) $< -o $@
 
 sha1.o: sha1.c byte_order.h ustd.h sha1.h
+	$(CC) -c $(CFLAGS) $< -o $@
+
+sha_ni.o: sha_ni.c sha_ni.h sha1.h ustd.h sha256.h byte_order.h
 	$(CC) -c $(CFLAGS) $< -o $@
 
 sha256.o: sha256.c byte_order.h ustd.h sha256.h

=== debian/changelog ===
rhash (1.4.6-1) unstable; urgency=medium

  * New upstream version 1.4.6
  * d/librhash1.symbols: Add 2 functions
  * d/control: bump std-version to 4.7.2
  * d/copyright: update copyright year

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Wed, 14 May 2025 02:20:32 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Aleksey Kravchenko <rhash.admin@gmail.com>
 Build-Depends: debhelper-compat (= 13), libssl-dev (>= 3.0.0)
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: http://rhash.sourceforge.net
 Vcs-Git: https://salsa.debian.org/pkg-security-team/rhash.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/rhash

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules makefile that uses debhelper.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

-include /usr/share/dpkg/buildtools.mk
export CC

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CONFIGURE_FLAGS = \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	--with-install="install -p -m 755" \
	--enable-lib-static \
	--enable-gettext \
	--enable-openssl-runtime \
	--extra-cflags="$(CPPFLAGS) $(CFLAGS)" \
	--extra-ldflags="$(LDFLAGS)"

%:
	dh $@

override_dh_auto_configure:
	./configure $(CONFIGURE_FLAGS)

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	$(MAKE) print-info
	$(MAKE) test-lib-shared test-lib-static test
endif

override_dh_auto_install:
	# Install the program and its translation strings
	$(MAKE) DESTDIR=$(CURDIR)/debian/rhash install-binary install-data install-symlinks install-gmo
	# Install static library and so link
	$(MAKE) DESTDIR=$(CURDIR)/debian/librhash-dev install-lib-static install-lib-so-link install-pkg-config
	# Install shared library
	$(MAKE) DESTDIR=$(CURDIR)/debian/librhash1 install-lib-shared

override_dh_auto_clean:
	[ -f config.mak ] && $(MAKE) distclean || true
